//----------------------------------------------------------------------------
// Fourier.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Fourier.pas
//----------------------------------------------------------------------------
#ifndef FourierHPP
#define FourierHPP
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
namespace Fourier
{
//-- type declarations -------------------------------------------------------
enum TFastFourierWgtWin { fwRectangle, fwTriangle, fwCos2, fwGauss, fwHamming, fwBlackman };

class __declspec(delphiclass) TFastFourier;
class __declspec(pascalimplementation) TFastFourier : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	int FNumData;
	void *FData;
	TFastFourierWgtWin FWgtWin;
	bool MaxValuesValid;
	double FMaxReal;
	double FMaxImag;
	double FMinReal;
	double FMinImag;
	double FMaxPower;
	double __fastcall GetRealVal(int p0);
	void __fastcall SetRealVal(int p0, double p1);
	double __fastcall GetImagVal(int p0);
	void __fastcall SetImagVal(int p0, double p1);
	void __fastcall SetNumData(int p0);
	void __fastcall SetWgtWin(TFastFourierWgtWin p0);
	double __fastcall GetPowerSpec(int p0);
	double __fastcall GetMaxPower(void);
	double __fastcall GetMaxReal(void);
	double __fastcall GetMaxImag(void);
	double __fastcall GetMinReal(void);
	double __fastcall GetMinImag(void);
	void __fastcall DoFFT(int p0);
	void __fastcall CalcMaxValues(void);
	
public:
	__fastcall virtual TFastFourier(Classes::TComponent* p0);
	__fastcall virtual ~TFastFourier(void);
	__property double RealSpec[int ix] = {read=GetRealVal, write=SetRealVal};
	__property double ImagSpec[int ix] = {read=GetImagVal, write=SetImagVal};
	void __fastcall Clear(void);
	void __fastcall ClearImag(void);
	void __fastcall ClearReal(void);
	void __fastcall Transform(void);
	void __fastcall InverseTransform(void);
	__property double PowerSpec[int ix] = {read=GetPowerSpec};
	__property double PowerMax = {read=GetMaxPower};
	__property double RealMax = {read=GetMaxReal};
	__property double ImagMax = {read=GetMaxImag};
	__property double RealMin = {read=GetMinReal};
	__property double ImagMin = {read=GetMinImag};
	__property void * DataBuffer = {read=FData, nodefault};
	
__published:
	__property int SpectrumSize = {read=FNumData, write=SetNumData, nodefault};
	__property TFastFourierWgtWin WeightingWindow = {read=FWgtWin, write=SetWgtWin, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);

}	/* namespace Fourier */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Fourier;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Fourier
